unit kl_bruch;

interface

uses sysutils;

type
  TBruch = class(TObject)
           protected
             zaehler : Integer;
             nenner  : Integer;
             function ggT(a, b: Integer): Integer;
           public
             constructor Create(i_zaehler, i_nenner: Integer);
             destructor Destroy; override;
             function   AsString: String;
             function   GetZaehler: Integer;
             function   GetNenner : Integer;
             procedure  Reset(n_zae, n_nen: Integer);
             procedure  Kuerze;
           end;

implementation

{=============== Methoden von TBruch =========================}

constructor TBruch.Create(i_zaehler, i_nenner: Integer);
  begin
  Inherited Create;
  Reset(i_zaehler, i_nenner);
  end;

destructor TBruch.Destroy;
  begin
  Inherited Destroy;
  end;

function TBruch.ggT(a, b: Integer): Integer;
  var r : Integer;
  begin
  If a < b then begin
    r := a; a := b; b := r;
    end;
  While b > 0 do begin
    r := a MOD b;
    a := b;
    b := r;
    end;
  Result := a;
  end;

function TBruch.AsString: String;
  begin
  Result := IntToStr(zaehler) + '/' + IntToStr(nenner);
  end;

function TBruch.GetZaehler: Integer;
  begin
  Result := zaehler;
  end;

function TBruch.GetNenner: Integer;
  begin
  Result := nenner;
  end;

procedure TBruch.Reset(n_zae, n_nen: Integer);
  begin
  If n_nen = 0 then begin   // Falsche Eingabe !
    zaehler := 0;              // Dummy-Werte
    nenner  := 1;              // setzen
    end
  else begin                // Nenner ist <> 0 !
    If n_nen > 0 then begin    // Nenner > 0
      zaehler := n_zae;
      nenner  := n_nen;
      end
    else begin                 // Nenner < 0
      zaehler := - n_zae;
      nenner  := - n_nen;
      end;
    end;
  end;

procedure TBruch.Kuerze;
  var k : Integer;
  begin
  k := ggT(Abs(zaehler), Abs(nenner));
  zaehler := zaehler div k;
  nenner  := nenner  div k;
  end;

end.
